var search_c;
var type_action, show_type, type_tri;
var is_editing=false;
$.trumbowyg.svgPath = 'css/icons.svg';
// cacher les sous-menus
$("[data-hideonstart='oui']").hide();
$(document).ready(function(){
    /*  - - - - - - - - tools  */
    // elements de menu à montrer ou cacher

    $("a[data-showhide]").click(function(){
        var dest=$(this).attr("data-showhide");
        if($(this).hasClass("actif")){
            $(this).removeClass("actif");
            $("#"+dest).slideUp("fast");
        } else {
            $("a[data-showhide]").removeClass("actif");
            $("#toolbar [id^='tool-']").slideUp("fast");

            $(this).addClass("actif");
            $("#"+dest).slideDown("fast");
        }
        return false;
    });
    $('#live-search').keyup(function(){
        filtre_items();
    });

    // - - - - - - - affichage
    // ajouter/retirer data-affichage-texte par exemple 
    // en fonction des critères encodé
    //
    var valeurs=cookie_get("items-infos");
    if(valeurs != undefined){
        $("body").attr("data-items-infos",valeurs);
    } else {
        valeurs=$("body").attr("data-items-infos");
    }
    coche_criteres(valeurs,"#tool-items-infos");
    infos_affiche_items();
    $("#tool-items-infos [data-critere]").click(function(){
        infos_modifier_critere("items-infos");
        infos_affiche_items();
    });

    // - - - - - -zones de recherche
    valeurs=cookie_get("items-search");
    if(valeurs != undefined){
        $("body").attr("data-items-search",valeurs);
    } else {
        valeurs=$("body").attr("data-items-search");
    }
    coche_criteres(valeurs,"#tool-items-search");
    $("#tool-items-search [data-critere]").click(function(){
        infos_modifier_critere("items-search");
        search_c=charge_search_elem();
        filtre_items();
    });
    search_c=charge_search_elem();

    // - - - - - - - tri
    type_tri=$("body").attr("data-type-tri");
    var tri=cookie_get("tool-tri");
    if(tri != undefined){
        $("#tool-tri [data-critere='"+tri+"']").prop('checked',true);
        $("body").attr("data-type-tri",tri);
        type_tri=tri;
    }
    trie_items();
    $("#tool-tri input").click(function(){
        var cle=$("#tool-tri input:checked").attr("data-critere");
        console.log("cle changée "+cle);
        Cookies.set("tool-tri", cle);
        trie_items();
    });
    // - - - - - type d'action en click
    type_action=$("body").attr("data-type-action");
    var action=cookie_get("tool-action");
    if(action != undefined){
        $("body").attr("data-type-action",action);
        $("#tool-action [data-critere='"+action+"']").prop('checked',true);
        type_action=action;
    }
    $("#tool-action input").click(function(){
        type_action=$(this).attr("data-critere");
        $("body").attr("data-type-action", type_action).attr("display-viewer","off");

        Cookies.set("tool-action", type_action);
    });
    // - - - - - afficher items ou collection
    show_type=$("body").attr("data-type-affichage");
    var type=cookie_get("tool-affichage");
    if(type != undefined){
        $("#tool-affichage [data-critere='"+type+"']").prop('checked',true);
        $("body").attr("data-type-affichage",type);
        show_type=type;
    }
    $("#tool-affichage input").click(function(){
        show_type=$(this).attr("data-critere");
        $("body").attr("data-type-affichage", show_type);
        Cookies.set("tool-affichage", show_type);
    });
    init_login();
});

/* gestion du clavier */
$(document).keydown(function(e){
    if(is_editing==false){ // pas de fleches si on edite item ou texte
        if (e.keyCode == 39){
            item_suivant();
        } else if (e.keyCode == 37){ 
            item_precedent();

        } 
    }
    if (e.keyCode == 27){
        // tout cacher
        close_viewer();
    }
});

// cocher les criteres par checkbox
function coche_criteres(valeurs,menu){
    $(menu+" [data-critere]").prop('checked',false);
    valeurs=valeurs.split(",");
    valeurs.forEach(function (tag) {
        $(menu+" [data-critere='"+tag+"']").prop('checked',true);
    });
}

// affichage des infos dans la liste d'items
function infos_affiche_items(){
    $(".item [data-contenu]").hide();
    var valeur=$("body").attr("data-items-infos");
    valeur=valeur.split(",");
    valeur.forEach(function(tag) {
        $(".item [data-contenu='"+tag+"']").show();
    }); 
}

//infos_modifier_critere($(this),bodydata,cookiedata);
function infos_modifier_critere(menu){
    var valeurs=[];
    $("#tool-"+menu+" [data-critere]").each(function(){
        if($(this).is(":checked")){
            valeurs.push($(this).attr("data-critere"));
        }
    });
    valeurs=valeurs.join(",");
    $("body").attr("data-"+menu,valeurs); 
    Cookies.set(menu, valeurs);
}

function trie_items(){
    var cle=$("#tool-tri input:checked").attr("data-critere");
    sortliste=[];
    var cletri=$("#items-container").attr("data-cle");

    $("#items-container .item").each(function(){
        var i=$(this).attr("data-xml");
        var t=$(this).find("[data-contenu='"+cletri+"']").text();
        sortliste.push({id: i, titre: t});
    });

    if(cle=="alpha"){
        sortliste.sort(function(a,b) {
            return a.titre > b.titre;
        });
    }
    if(cle=="antialpha"){
        sortliste.sort(function(a,b) {
            return b.titre > a.titre;
        });
    }
    if(cle=="byid"){
        sortliste.sort(function(a,b) {
            return a.id > b.id;
        });
    } 
    if(cle=="byantiid"){
        sortliste.sort(function(a,b) {
            return b.id > a.id;
        });
    }
    console.log("tri "+cle);
    // utiliser order en css
    var compteur=0;
    sortliste.forEach(function(item){
        // donner la css à chaque element
        $("#items-container .item[data-xml='"+item.id+"']").appendTo("#items-container"); //css("order",compteur);
        compteur++;
    });
}

function item_click(elem){
    $("#items-container .item.actuel").removeClass("actuel");
    var item=$(elem).closest( ".item" ).addClass("actuel");
    item_show();
}

function item_suivant(){
    var i=$("#items-container .item.actuel").eq(0);
    if(i.length==0){
        i=$("#items-container .item:visible").eq(0);
        i.addClass("actuel");
    }
    var n=$(i).nextAll(".item:visible:first");
    if(n.length>0){
        $(n).addClass("actuel");
        $(i).removeClass("actuel");
    } else {
        //alert("rien apres");
    }
    if($("body").attr("display-viewer")=="on"){
        item_show();
    }
}

function item_precedent(){
    var i=$("#items-container .item.actuel").eq(0);
    if(i.length==0){
        i=$("#items-container .item:visible:last");
        i.addClass("actuel");
    }
    var p=$(i).prevAll(".item:visible:first");
    if(p.length>0){
        $(i).removeClass("actuel");
        $(p).addClass("actuel");
    } else {
        //alert("rien avant");
    }
    if($("body").attr("display-viewer")=="on"){
        item_show();
    }
}

// affichage de l'élément si un des systeme d'info est ouvet 
function item_show(){
    var actuel=$("#items-container .item.actuel");
    var xml=actuel.attr("data-xml");

    switch(type_action) {
        case "showgal":
            //display_showgal(item);
            data={ "xml": xml, "display": "item-galerie" };
            fill_viewer(data,"inc/inc-ajax-display.php","fullpage-container","full");
            break;
        case "showlateral":
            data={ "xml": xml, "display": "item-lateral" };
            fill_viewer(data,"inc/inc-ajax-display.php","side-container","full");
            break;
        case "showfullpage":
            data={ "xml": xml, "display": "item-fullpage" };
            fill_viewer(data,"inc/inc-ajax-display.php","fullpage-container","full");
            break; 
        case "showslidepage":
            data={ "xml": xml, "display": "item-lateral" };
            fill_viewer(data,"inc/inc-ajax-display.php","item-container","full");
            break;
        default:
            // code block
            alert("erreur d'action");
    } 

}

function cookie_get(nom, defaut){
    if(Cookies.get(nom)!=undefined){
        return Cookies.get(nom);
    } else {
        return defaut;
    } 
}

function filtre_items(){
    var val = $('#live-search').val().toLowerCase();
    if(val.length > 1){
        $(".item").each(function(){
            var elem=$(this);
            var text="";
            search_c.forEach(function(item){
                //item=item.replace("s-", "");
                text+=elem.find("[data-contenu='"+item+"']").text().toLowerCase();
                text+=" ";
            });
            if(text.indexOf(val) != -1) {
                elem.fadeIn();
            } else {
                elem.fadeOut();
            }
        }); 
    } else {
        $(".item").fadeIn();
    }
}

/* Gestion des containers          - - - -            */
function close_viewer(){
    $("body").attr("display-viewer","off");
    $(".container-inner").empty();
    document.exitFullscreen();
    is_editing=false;
}

function charge_search_elem(){
    var c=[];
    $("#tool-items-search [data-critere]:checked").each(function(){
        c.push($(this).attr("data-critere"));
    });
    return c;
}

function item_ajouter(){
    var url="inc/inc-ajax-form.php?";
    $.ajax({
        type: "POST",
        url: url,
        success: function(msg){
            $("#side-container .container-inner").html(msg);
        },
        complete: function(){
            $("body").attr("display-viewer","on").attr("display-container","side-container");
            init_ajax_submit_item("");
        },
        error: function(e) {
            alert("Une erreur de chargement. Désolé.");
        }
    });
    return false;
}

function item_edit(item){
    var url="inc/inc-ajax-form.php";
    $.ajax({
        type: "GET",
        url: url,
        data: {xml: item},
        success: function(msg){
            $("#side-container .container-inner").html(msg);
            is_editing=true;
        },
        complete: function(){
            $("body").attr("display-viewer","on").attr("display-container","side-container");
            $("#side-container").attr("data-nav","only-close");
            init_ajax_submit_item(item);
        },
        error: function(e) {
            alert("Une erreur de chargement. Désolé.");
        }
    });
}

function init_ajax_submit_item(item){
    $('textarea').trumbowyg({
        lang: 'fr',
        btns: [
            ['viewHTML'],
            ['undo', 'redo'], // Only supported in Blink browsers
            ['formatting'],
            ['strong', 'em'],
            ['link'],
            ['justifyLeft', 'justifyCenter'],
            ['removeformat']
        ] 
    });

    if(item){ 
        var url_item="?xml="+item; 
    } else { 
        var url_item=""; 
    }
    $("#side-container form").on('submit',(function(e) {
        e.preventDefault();
        $.ajax({
            url: "inc/inc-ajax-form.php"+url_item,
            type: "POST",
            data:  new FormData(this),
            contentType: false,
            cache: false,
            processData:false,
            beforeSend : function(){

            },
            success: function(data){
                // ici, on injecte le nouveau item ou update l'existant
                if(data =="delete"){
                    $("#items-container [data-xml='"+item+"']").remove();
                    // supprimer l'element
                } else {
                    if(item){
                        $("#items-container [data-xml='"+item+"']").replaceWith(data);
                    } else {
                        $("#items-container").append(data);
                    }
                    infos_affiche_items();
                    is_editing=false;
                }
            },
            complete: function(){
                close_viewer();
                is_editing=false;
            },
            error: function(e) {
                alert("Une erreur de traitement ");
                //$("#err").html(e).fadeIn();
            }          
        });
    }));
} 

function show_next(elem){
    $(elem).next().fadeIn('fast');
    return false;
}

// procédure générique d'affichage dans les contenueurs
// exemple: fill_viewer("truc.xml","inc-ajax-display.php","#galerie-container","full");
// parametres: xml, page appelée, element vers lequel envoyer, boutons à aficher (full ou only-close)
function fill_viewer(data,url,destination,nav){
    $.ajax({
        url: url,
        method: "GET",
        data: data,
        beforeSend : function(){
            $("#"+destination).addClass("wait");
            $("body").attr("display-viewer","on").attr("display-container",destination);
        },
        success: function(data){
            $("#"+destination+" .container-inner").html(data); 
            $("#"+destination).attr("data-nav",nav);
        },
        complete: function(){
            $("#"+destination).removeClass("wait");
            $('textarea').trumbowyg({
                lang: 'fr',
                btns: [
                    ['viewHTML'],
                    ['undo', 'redo'], // Only supported in Blink browsers
                    ['formatting'],
                    ['strong', 'em'],
                    ['link'],
                    ['justifyLeft', 'justifyCenter'],
                    ['removeformat']
                ]
            }); 
        },
        error: function(e) {
            alert("Une erreur de traitement. Désolé.");
        }          
    });
}


// init_fullpage : un click sur l'image princpale replace celle-ci par les images de la galerie
function init_fullpage(){
    var nb_im=$("#fullpage-container img").length;
    if(nb_im > 1){
        $(".viewer-main-illu").css("cursor","pointer").attr("data-compteur",0).click(function(){
            var ca=$(".viewer-main-illu").attr("data-compteur");
            ca++;
            var src=$("#fullpage-container [data-original]").eq(ca).attr("data-original");
            if(src==undefined){
                src=$("#fullpage-container [data-original]").eq(0).attr("data-original");
                ca=0;
            }
            $(".viewer-main-illu").attr("src",src);
            $(".viewer-main-illu").attr("data-compteur",ca);
        });
    }
}

function show_page(page){
    data={ "page": page, "display": "item-page" };
    fill_viewer(data,"inc/inc-ajax-display.php","side-container","only-close");
    return false;
}
function list_pages(){
    fill_viewer('','inc/inc-ajax-list-pages.php','side-container','only-close');
}
function edit_page(page){
    data={ "page": page };
    fill_viewer(data,'inc/inc-ajax-list-pages.php','side-container','only-close');
    is_editing=true;
    return false;
}

function init_ajax_submit_page(page){
    $("#side-container form").on('submit',(function(e) {
        e.preventDefault();
        $.ajax({
            url: "inc/inc-ajax-list-pages.php?page_edit="+page,
            type: "POST",
            data:  new FormData(this),
            contentType: false,
            cache: false,
            processData:false,
            beforeSend:function(){
            },
            success: function(retour){
                // ici, on injecte le nouveau item ou update l'existant
                // recharger la page
                $("#side-container .container-inner").html(retour);
                $("#side-container").attr("data-nav","only-close");
                //fill_viewer('','inc/inc-ajax-list-pages.php','side-container','only-close');
            },
            complete: function(){
                //close_viewer(); 
            },
            error: function(e) {
                alert("Une erreur de traitement ");
                //$("#err").html(e).fadeIn();
            }          
        });
    }));
} 

function ajouter_zip(){
    fill_viewer("truc.xml","inc/inc-add-zip.php","side-container","only-close");
    setTimeout(function(){ init_form_zip(); }, 2000);
}

function init_form_zip(){
    $('#form-zip').on('submit', function(e) {
        e.preventDefault(); // J'empêche le comportement par défaut du navigateur, c-à-d de soumettre le formulaire
        var $this = $(this); // L'objet jQuery du formulaire
        var form = $('#form-zip')[0];

        // Create an FormData object 
        var data = new FormData(form);
        data.append("submit-zip", "oui");
        // Envoi de la requête HTTP en mode asynchrone
        $.ajax({
            url: "inc/inc-add-zip.php",
            type: "POST",
            enctype: 'multipart/form-data',
            data: data,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 600000,
            beforeSend: function(){
                $("#side-container").addClass("wait");
            },
            success: function(datar){
                $("#side-container .container-inner").html(datar);
                is_editing=true;
            }, 
            complete: function(){
                // lancer le formulaire d'import
                fill_viewer("truc.xml","inc/inc-add-items.php","side-container","only-close");
                $("#side-container").removeClass("wait");
            },
            error: function(e) {
                alert("Une erreur de traitement ");
            }          
        });
    });
}

function ajouter_items(){
    fill_viewer("truc.xml","inc/inc-add-items.php","side-container","only-close");
}

function import_toggle_item(elem){
    if($(elem).attr("data-import")=="true"){
        $(elem).attr("data-import","false");
    } else {
        $(elem).attr("data-import","true");
    }
}

function import_proceed(){
    var elem=$("#import-list [data-import='true']:first");

    if(elem.length > 0){
        var lien=elem.attr("data-source");
        var params = $("#import_infos form").serialize()+"&import="+lien;

        $.ajax({
            url: "inc/inc-add-items.php",
            type: "post",
            data: params,
            //data: data + '&import=' + lien ,
            //data: { "import": lien },
            success: function(retour){
                // reçoit le bloc
                $("#items-container").append(retour);
                //alert(retour);
            },
            complete: function(){
                $(elem).remove();
            },
            error: function(e) {
                alert("Une erreur de traitement ");
                //$("#err").html(e).fadeIn();
            }          
        });
        window.setTimeout("import_proceed()",500);
    }  
}

function init_login(){
    $('.form-login').on('submit', function(e) {
        e.preventDefault(); // J'empêche le comportement par défaut du navigateur, c-à-d de soumettre le formulaire
        var $this = $(this); // L'objet jQuery du formulaire

        // Envoi de la requête HTTP en mode asynchrone
        $.ajax({
            url: "inc/inc-ajax-login.php",
            type: "post",
            data: $this.serialize(),
            success: function(data){
                //alert(data);
                $("#admin-menu").html(data);
                init_login();
            },
            error: function(e) {
                alert("Une erreur de traitement "+e);
                //$("#err").html(e).fadeIn();
            }          
        });
    });
}

function logout(){
    $.ajax({
        url: "inc/inc-ajax-login.php",
        type: "post",
        data: {logout: "logout"},
        success: function(data){
            //alert(data);
            $("#admin-menu").html(data);//load("inc/inc-admin-menu.php");
            init_login();
        },
        error: function(e) {
            alert("Une erreur de traitement "+e);
            //$("#err").html(e).fadeIn();
        }          
    });
}

function vider_cache(lequel){
    $.ajax({
        url: "inc/inc-ajax-display.php",
        type: "get",
        data: {vider_cache: lequel},
        success: function(data){
            alert("cache image "+lequel+" - rechargez");
        },
        error: function(e) {
            alert("Cache non vidé - erreur "+e);
            //$("#err").html(e).fadeIn();
        }          
    });
}

function visible_check(elem){
    $(elem).toggleClass('check');
}

function form_input_duclicate(elem){
    var lequel=$(elem).attr("data-duplicate");
    var contenu=$( "[data-form-base='"+lequel+"']" ).eq(0).clone();
    contenu.children("input").val("");
    $(elem).parent().before(contenu);
}

function viewer_show_image(elem){
    var image=$(elem).attr("data-original");
    $(".viewer-main-illu:visible").attr("src",image);
    $(".viewer-main-illu:visible").next(".button-back").show();
}
function viewer_back_image(){
    var image=$(".viewer-main-illu:visible").attr("data-original");
    $(".viewer-main-illu:visible").attr("src",image);
    $(".viewer-main-illu:visible").next(".button-back").hide();
}

function image_rotate(image_url,angle,item_url){
    $.ajax({
        method: "POST",
        url: "inc/inc-ajax-display.php",
        data: { url: image_url, angle: angle, rotation_image: 1 },
        beforeSend: function() {

            //$("#main-editor").empty().addClass("wait");
            //montre_colonne_display();
        }
    }).success(function( msg ) {
        $("#side-container [data-original='"+image_url+"']").attr('src','msg');
        $("[data-xml='"+item_url+"'] img").attr('src','msg');
        //item_update_info(item_url);
        //item_vignette_updater(item_url);
    }).complete(function(){
        // remplacer li'image dans le form
        // remplacer l'image dans l'item
        //$("#items-container ")
    });
}


function openFullscreen() {
    var elem = $("#fullpage-container").get(0);
    if (elem.requestFullscreen) {
        elem.requestFullscreen();
    } else if (elem.mozRequestFullScreen) { /* Firefox */
        elem.mozRequestFullScreen();
    } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari & Opera */
        elem.webkitRequestFullscreen();
    } else if (elem.msRequestFullscreen) { /* IE/Edge */
        elem.msRequestFullscreen();
    }
}